NX Open C++ Reference Guide
|
Represents a section
Section consists of "chained_entity", a chain or a single entity of edge or curve.
More...
Public Member Functions | |
void | AddChainBetweenIntersectionPoints (const std::vector< NXOpen::SelectionIntentRule * > &rules, NXOpen::NXObject *startConnector, const NXOpen::Point3d &startIntersectionPoint, NXOpen::NXObject *endConnector, const NXOpen::Point3d &endIntersectionPoint, NXOpen::NXObject *seed, const NXOpen::Point3d &helpPoint, NXOpen::Section::Mode featureMode, bool chainWithinFeature) |
Adds a chain between given two intersection points to the section. | |
void | AddSmartPoint (NXOpen::Point *smartPt, double tol) |
Add smart point into section. | |
void | AddToSection (const std::vector< NXOpen::SelectionIntentRule * > &rules, NXOpen::NXObject *seed, NXOpen::NXObject *startConnector, NXOpen::NXObject *endConnector, const NXOpen::Point3d &helpPoint, NXOpen::Section::Mode featureMode) |
Adds selection intent rules to the section. | |
void | AddToSection (const std::vector< NXOpen::SelectionIntentRule * > &rules, NXOpen::NXObject *seed, NXOpen::NXObject *startConnector, NXOpen::NXObject *endConnector, const NXOpen::Point3d &helpPoint, NXOpen::Section::Mode featureMode, bool chainWithinFeature) |
Adds selection intent rules to the section with the option of restricting chaining and limit discovery to a single feature. | |
void | AlignDirectionOfLoop (const NXOpen::Point3d &point, const NXOpen::Vector3d &direction) |
Set the direction of a single loop of the section along the given vector. | |
void | AllowSelfIntersection (bool allowSelfIntersection) |
Allow self intersecting section or not. | |
double | AngleTolerance () |
Returns the angle tolerance Created in NX3.0.0. | |
double | ChainingTolerance () |
Returns the chaining tolerance Created in NX3.0.0. | |
void | CleanMappingData () |
Cleans Mapping Data This method should be used to clean mapping data after mapping is done | |
void | Clear () |
Clear the section of all its constituents Created in NX5.0.0. | |
NXOpen::Section * | CloneSection () |
Clone section. | |
void | DeselectPortion (const NXOpen::Point3d &seedPoint, NXOpen::NXObject *startLimit, NXOpen::NXObject *endLimit, NXOpen::Section::DeselectOption deselectionType) |
Deselects Portion of the section depending on the option provided. | |
void | Destroy () |
Destroy the section object Created in NX4.0.0. | |
double | DistanceTolerance () |
Returns the distance tolerance Created in NX3.0.0. | |
void | EvaluateAndAskOutputEntities (std::vector< NXOpen::NXObject * > &refs) |
Recalculates section collection. | |
NXOpen::Section::AllowTypes | GetAllowedEntityTypes () |
Get the Allowed Entity Types. | |
int | GetLoopIndex (NXOpen::NXObject *sectionElement) |
Returns the index of the section loop conatining the section element. | |
int | GetLoopIndex (const NXOpen::Point3d &pointSpecifyingLoop, double tolerance) |
Returns the index of the loop on which the given point lies. | |
bool | GetMultiComponent () |
Gets the option set on Section for collection from multiple components. | |
bool | GetNonFeatureMode () |
Gets the option set on Section for collection in non-feature mode. | |
void | GetOldOutputCurves (std::vector< NXOpen::NXObject * > &oldOutputs) |
Gives the old output curves of the section. | |
void | GetOutputCurves (std::vector< NXOpen::NXObject * > &outputs) |
Gives the output curves of the section. | |
void | GetSectionData (std::vector< NXOpen::SectionData * > §ionData) |
Gets the section data Created in NX3.0.0. | |
void | GetStartAndDirection (NXOpen::ICurve **startElement, NXOpen::Point3d *startPoint, NXOpen::Vector3d *direction) |
Gets the start element and the direction of the section. | |
void | GetStartAndDirectionOfLoop (int index, NXOpen::Point3d *startPoint, NXOpen::Vector3d *direction) |
Gets the start point and the direction of a specified single loop of the section. | |
void | MapSectionElements (NXOpen::NXObject *oldWf, NXOpen::NXObject *newWf) |
Maps old section curves to new section curves This method should be used to map old section curves to new section curves when some or all curves from section are removed and some or all new curves are added. | |
void | PrepareMappingData () |
Prepares Mapping Data This method should be used to create mapping data if mapping is to be done Created in NX7.5.0. | |
void | RemoveMultipleCurves (const std::vector< NXOpen::ICurve * > &wfs, const std::vector< NXOpen::NXObject * > &startConnector, const std::vector< NXOpen::NXObject * > &endConnector, NXOpen::Section::Mode featureMode) |
Removes multiple section elements that are either curves/edges. | |
void | RemoveMultipleElements (const std::vector< NXOpen::ICurve * > &wfs, const std::vector< NXOpen::NXObject * > &startConnectors, const std::vector< NXOpen::NXObject * > &endConnectors, const std::vector< bool > &isCombinationsResultIntoOnlyOneCurvePerCombination, const std::vector< NXOpen::Point3d > &pointsOnCurvesToBeRemoved, const std::vector< NXOpen::Point * > &points, NXOpen::Section::Mode featureMode) |
Removes multiple section elements. | |
void | RemoveMultiplePoints (const std::vector< NXOpen::Point * > &points, NXOpen::Section::Mode featureMode) |
Removes multiple section elements that are points. | |
void | RemoveRules (const std::vector< NXOpen::SelectionIntentRule * > &rules, NXOpen::NXObject *startConnector, NXOpen::NXObject *endConnector, NXOpen::Section::Mode featureMode) |
Removes selection intent rules from the section. | |
void | RemoveRules (NXOpen::ICurve *sectionElement, NXOpen::NXObject *startConnector, NXOpen::NXObject *endConnector, NXOpen::Section::Mode featureMode) |
Removes all the selection intent rules related to the section element. | |
void | RemoveSingleSectionElement (NXOpen::ICurve *sectionElement, NXOpen::NXObject *startConnector, NXOpen::NXObject *endConnector, NXOpen::Section::Mode featureMode) |
Removes one section element curve. | |
void | RemoveSingleSectionElement (NXOpen::Point *sectionElement, NXOpen::Section::Mode featureMode) |
Removes one section element that is a point. | |
void | RemoveUnderlyingChain (const NXOpen::Point3d &pointSpecifyingChain, double tolerance, NXOpen::Section::Mode featureMode) |
Removes all the selection intent rules related to the chain on which the given point lies. | |
void | RemoveUnderlyingCurve (const NXOpen::Point3d &pointSpecifyingCurve, double tolerance, NXOpen::Section::Mode featureMode) |
Removes the single curve which is within tolerance to the given point, from the section. | |
void | ReverseDirection () |
Reverse the section direction Created in NX4.0.0. | |
void | ReverseDirectionOfClosedLoop (int index) |
Reverse the loop direction of a closed loop while keeping the start curve same. | |
void | ReverseDirectionOfLoop (int index) |
Reverse the direction of of a specified single loop of the section. | |
void | SetAllowedEntityTypes (NXOpen::Section::AllowTypes allowedEntityTypes) |
Set the Allowed Entity Types. | |
void | SetAngleTolerance (double angleTolerance) |
Sets the angle tolerance Created in NX3.0.0. | |
void | SetChainingTolerance (double chainingTolerance) |
Sets the chaining tolerance Created in NX3.0.0. | |
void | SetDistanceTolerance (double distanceTolerance) |
Sets the distance tolerance Created in NX3.0.0. | |
void | SetInterpart (bool interpart) |
Set inter-part state of section and make it empty. | |
void | SetMultiComponent () |
Sets the true option on Section for collection from multiple components. | |
void | SetNonFeatureMode () |
Sets the true option on Section for collection in non-feature mode. | |
void | SetStartAndDirection (NXOpen::ICurve *startElement, const NXOpen::Point3d &startPoint, const NXOpen::Vector3d &direction) |
Sets the start element and the direction of the section. | |
void | SetStartCurveOfClosedLoop (int index, const NXOpen::Point3d &pointOnStartCurve) |
Set the curve on which the specified point lies as the start curve of a specified single loop of the section. | |
void | SkipSorting (bool skipSorting) |
Sets the option to skip sorting the section loops or not. | |
![]() | |
void | Blank () |
Blanks the object. | |
int | Color () |
Returns the color of the object. | |
void | Highlight () |
Highlights the object. | |
bool | IsBlanked () |
Returns the blank status of this object. | |
int | Layer () |
Returns the layer that the object is in. | |
NXOpen::DisplayableObject::ObjectFont | LineFont () |
Returns the line font of the object. | |
NXOpen::DisplayableObject::ObjectWidth | LineWidth () |
Returns the line width of the object. | |
NXOpen::Point3d | NameLocation () |
Returns the location of the object's name. | |
void | RedisplayObject () |
Redisplays the object in all views. | |
void | SetColor (int color) |
Sets the color of the object. | |
void | SetLayer (int layer) |
Sets the layer that the object is in. | |
void | SetLineFont (NXOpen::DisplayableObject::ObjectFont font) |
Sets the line font of the object. | |
void | SetLineWidth (NXOpen::DisplayableObject::ObjectWidth width) |
Sets the line width of the object. | |
void | SetNameLocation (const NXOpen::Point3d &location) |
Sets the location of the object's name. | |
void | Unblank () |
Unblanks the object. | |
void | Unhighlight () |
Unhighlights the object. | |
![]() | |
void | DeleteAllAttributesByType (NXOpen::NXObject::AttributeType type) |
Deletes all attributes of a specific type. | |
void | DeleteAllAttributesByType (NXOpen::NXObject::AttributeType type, NXOpen::Update::Option option) |
Deletes all attributes of a specific type with the option to update or not. | |
void | DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const NXString &title) |
Deletes an attribute by type and title. | |
void | DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const char *title) |
Deletes an attribute by type and title. | |
void | DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const NXString &title, NXOpen::Update::Option option) |
Deletes an attribute by type and title with the option to update or not. | |
void | DeleteAttributeByTypeAndTitle (NXOpen::NXObject::AttributeType type, const char *title, NXOpen::Update::Option option) |
Deletes an attribute by type and title with the option to update or not. | |
void | DeleteUserAttribute (NXOpen::NXObject::AttributeType type, const NXString &title, bool deleteEntireArray, NXOpen::Update::Option option) |
Deletes the first attribute encountered with the given Type, Title and Index. | |
void | DeleteUserAttribute (NXOpen::NXObject::AttributeType type, const char *title, bool deleteEntireArray, NXOpen::Update::Option option) |
Deletes the first attribute encountered with the given Type, Title and Index. | |
void | DeleteUserAttributes (NXOpen::NXObject::AttributeType type, NXOpen::Update::Option option) |
Deletes the attributes encountered with the given Type with option to update or not. | |
virtual NXOpen::INXObject * | FindObject (const NXString &journalIdentifier) |
Finds the NXObject with the given identifier as recorded in a journal. | |
NXOpen::INXObject * | FindObject (const char *journalIdentifier) |
Finds the NXObject with the given identifier as recorded in a journal. | |
std::vector < NXOpen::NXObject::AttributeInformation > | GetAttributeTitlesByType (NXOpen::NXObject::AttributeType type) |
Gets all the attribute titles of a specific type. | |
bool | GetBooleanUserAttribute (const NXString &title, int index) |
Gets a boolean attribute by Title and array Index. | |
bool | GetBooleanUserAttribute (const char *title, int index) |
Gets a boolean attribute by Title and array Index. | |
NXOpen::NXObject::ComputationalTime | GetComputationalTimeUserAttribute (const NXString &title, int index) |
Gets a time attribute by Title and array Index. | |
NXOpen::NXObject::ComputationalTime | GetComputationalTimeUserAttribute (const char *title, int index) |
Gets a time attribute by Title and array Index. | |
int | GetIntegerAttribute (const NXString &title) |
Gets an integer attribute by title. | |
int | GetIntegerAttribute (const char *title) |
Gets an integer attribute by title. | |
int | GetIntegerUserAttribute (const NXString &title, int index) |
Gets an integer attribute by Title and array Index. | |
int | GetIntegerUserAttribute (const char *title, int index) |
Gets an integer attribute by Title and array Index. | |
double | GetRealAttribute (const NXString &title) |
Gets a real attribute by title. | |
double | GetRealAttribute (const char *title) |
Gets a real attribute by title. | |
double | GetRealUserAttribute (const NXString &title, int index) |
Gets a real attribute by Title and array Index. | |
double | GetRealUserAttribute (const char *title, int index) |
Gets a real attribute by Title and array Index. | |
NXString | GetReferenceAttribute (const NXString &title) |
Gets the reference string (not the calculated value) of a string attribute that uses a reference string. | |
NXString | GetReferenceAttribute (const char *title) |
Gets the reference string (not the calculated value) of a string attribute that uses a reference string. | |
NXString | GetStringAttribute (const NXString &title) |
Gets a string attribute value by title. | |
NXString | GetStringAttribute (const char *title) |
Gets a string attribute value by title. | |
NXString | GetStringUserAttribute (const NXString &title, int index) |
Gets a string attribute by Title and array Index. | |
NXString | GetStringUserAttribute (const char *title, int index) |
Gets a string attribute by Title and array Index. | |
NXString | GetTimeAttribute (NXOpen::NXObject::DateAndTimeFormat format, const NXString &title) |
Gets a time attribute by title. | |
NXString | GetTimeAttribute (NXOpen::NXObject::DateAndTimeFormat format, const char *title) |
Gets a time attribute by title. | |
NXString | GetTimeUserAttribute (const NXString &title, int index) |
Gets a time attribute by Title and array Index. | |
NXString | GetTimeUserAttribute (const char *title, int index) |
Gets a time attribute by Title and array Index. | |
NXOpen::NXObject::AttributeInformation | GetUserAttribute (const NXString &title, NXOpen::NXObject::AttributeType type, int index) |
Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. | |
NXOpen::NXObject::AttributeInformation | GetUserAttribute (const char *title, NXOpen::NXObject::AttributeType type, int index) |
Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. | |
NXString | GetUserAttributeAsString (const NXString &title, NXOpen::NXObject::AttributeType type, int index) |
Gets the first attribute encountered on the object, if any, with a given title, type and array index. | |
NXString | GetUserAttributeAsString (const char *title, NXOpen::NXObject::AttributeType type, int index) |
Gets the first attribute encountered on the object, if any, with a given title, type and array index. | |
bool | GetUserAttributeLock (const NXString &title, NXOpen::NXObject::AttributeType type) |
Determine the lock of the given attribute. | |
bool | GetUserAttributeLock (const char *title, NXOpen::NXObject::AttributeType type) |
Determine the lock of the given attribute. | |
std::vector < NXOpen::NXObject::AttributeInformation > | GetUserAttributes () |
Gets all the attributes that have been set on the given object. | |
std::vector < NXOpen::NXObject::AttributeInformation > | GetUserAttributes (bool includeUnset) |
Gets all the attributes that have been set on the given object. | |
std::vector < NXOpen::NXObject::AttributeInformation > | GetUserAttributes (bool includeUnset, bool addStringValues) |
Gets all the attributes that have been set on the given object. | |
std::vector< NXString > | GetUserAttributesAsStrings () |
Gets all the attributes that have been set on the given object. | |
std::vector< NXOpen::NXObject * > | GetUserAttributeSourceObjects () |
Returns an array of objects from which this object presents attributes. | |
bool | HasUserAttribute (const NXString &title, NXOpen::NXObject::AttributeType type, int index) |
Determines if an attribute with the given Title, Type and array Index is present on the object If the attribute is not an array, the Index is ignored (if this is known beforehand, we recommend setting the Index to -1 to save time). | |
bool | HasUserAttribute (const char *title, NXOpen::NXObject::AttributeType type, int index) |
Determines if an attribute with the given Title, Type and array Index is present on the object If the attribute is not an array, the Index is ignored (if this is known beforehand, we recommend setting the Index to -1 to save time). | |
virtual bool | IsOccurrence () |
Returns whether this object is an occurrence or not. | |
virtual NXString | JournalIdentifier () |
Returns the identifier that would be recorded in a journal for this object. | |
virtual NXString | Name () |
Returns the custom name of the object. | |
virtual NXOpen::Assemblies::Component * | OwningComponent () |
Returns the owning component, if this object is an occurrence. | |
virtual NXOpen::BasePart * | OwningPart () |
Returns the owning part of this object Created in NX3.0.0. | |
virtual void | Print () |
Prints a representation of this object to the system log file. | |
virtual NXOpen::INXObject * | Prototype () |
Returns the prototype of this object if it is an occurrence. | |
void | SetAttribute (const NXString &title, int value) |
Creates or modifies an integer attribute. | |
void | SetAttribute (const char *title, int value) |
Creates or modifies an integer attribute. | |
void | SetAttribute (const NXString &title, int value, NXOpen::Update::Option option) |
Creates or modifies an integer attribute with the option to update or not. | |
void | SetAttribute (const char *title, int value, NXOpen::Update::Option option) |
Creates or modifies an integer attribute with the option to update or not. | |
void | SetAttribute (const NXString &title, double value) |
Creates or modifies a real attribute. | |
void | SetAttribute (const char *title, double value) |
Creates or modifies a real attribute. | |
void | SetAttribute (const NXString &title, double value, NXOpen::Update::Option option) |
Creates or modifies a real attribute with the option to update or not. | |
void | SetAttribute (const char *title, double value, NXOpen::Update::Option option) |
Creates or modifies a real attribute with the option to update or not. | |
void | SetAttribute (const NXString &title, const NXString &value) |
Creates or modifies a string attribute. | |
void | SetAttribute (const char *title, const char *value) |
Creates or modifies a string attribute. | |
void | SetAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option) |
Creates or modifies a string attribute with the option to update or not. | |
void | SetAttribute (const char *title, const char *value, NXOpen::Update::Option option) |
Creates or modifies a string attribute with the option to update or not. | |
void | SetAttribute (const NXString &title) |
Creates or modifies a null attribute which is an attribute with a title and no value. | |
void | SetAttribute (const char *title) |
Creates or modifies a null attribute which is an attribute with a title and no value. | |
void | SetAttribute (const NXString &title, NXOpen::Update::Option option) |
Creates or modifies a null attribute with the option to update or not. | |
void | SetAttribute (const char *title, NXOpen::Update::Option option) |
Creates or modifies a null attribute with the option to update or not. | |
void | SetBooleanUserAttribute (const NXString &title, int index, bool value, NXOpen::Update::Option option) |
Creates or modifies a boolean attribute with the option to update or not. | |
void | SetBooleanUserAttribute (const char *title, int index, bool value, NXOpen::Update::Option option) |
Creates or modifies a boolean attribute with the option to update or not. | |
virtual void | SetName (const NXString &name) |
Sets the custom name of the object. | |
void | SetName (const char *name) |
Sets the custom name of the object. | |
void | SetReferenceAttribute (const NXString &title, const NXString &value) |
Creates or modifies a string attribute which uses a reference string. | |
void | SetReferenceAttribute (const char *title, const char *value) |
Creates or modifies a string attribute which uses a reference string. | |
void | SetReferenceAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option) |
Creates or modifies a string attribute which uses a reference string, with the option to update or not. | |
void | SetReferenceAttribute (const char *title, const char *value, NXOpen::Update::Option option) |
Creates or modifies a string attribute which uses a reference string, with the option to update or not. | |
void | SetTimeAttribute (const NXString &title, const NXString &value) |
Creates or modifies a time attribute. | |
void | SetTimeAttribute (const char *title, const char *value) |
Creates or modifies a time attribute. | |
void | SetTimeAttribute (const NXString &title, const NXString &value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetTimeAttribute (const char *title, const char *value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetTimeUserAttribute (const NXString &title, int index, const NXString &value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetTimeUserAttribute (const char *title, int index, const char *value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetTimeUserAttribute (const NXString &title, int index, const NXOpen::NXObject::ComputationalTime &value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetTimeUserAttribute (const char *title, int index, const NXOpen::NXObject::ComputationalTime &value, NXOpen::Update::Option option) |
Creates or modifies a time attribute with the option to update or not. | |
void | SetUserAttribute (const NXOpen::NXObject::AttributeInformation &info, NXOpen::Update::Option option) |
Creates or modifies an attribute with the option to update or not. | |
void | SetUserAttribute (const NXString &title, int index, int value, NXOpen::Update::Option option) |
Creates or modifies an integer attribute with the option to update or not. | |
void | SetUserAttribute (const char *title, int index, int value, NXOpen::Update::Option option) |
Creates or modifies an integer attribute with the option to update or not. | |
void | SetUserAttribute (const NXString &title, int index, double value, NXOpen::Update::Option option) |
Creates or modifies a real attribute with the option to update or not. | |
void | SetUserAttribute (const char *title, int index, double value, NXOpen::Update::Option option) |
Creates or modifies a real attribute with the option to update or not. | |
void | SetUserAttribute (const NXString &title, int index, const NXString &value, NXOpen::Update::Option option) |
Creates or modifies a string attribute with the option to update or not. | |
void | SetUserAttribute (const char *title, int index, const char *value, NXOpen::Update::Option option) |
Creates or modifies a string attribute with the option to update or not. | |
void | SetUserAttribute (const NXString &title, int index, NXOpen::Update::Option option) |
Creates or modifies a null attribute with the option to update or not. | |
void | SetUserAttribute (const char *title, int index, NXOpen::Update::Option option) |
Creates or modifies a null attribute with the option to update or not. | |
void | SetUserAttributeLock (const NXString &title, NXOpen::NXObject::AttributeType type, bool lock) |
Lock or unlock the given attribute. | |
void | SetUserAttributeLock (const char *title, NXOpen::NXObject::AttributeType type, bool lock) |
Lock or unlock the given attribute. | |
![]() | |
tag_t | GetTag () const |
<b>Deprecated</b>:<br> Use Tag instead. | |
tag_t | Tag () const |
Returns the tag of this object. | |
![]() | |
NXOpen::INXObject * | FindObject (const char *journalIdentifier) |
Finds the NXObject with the given identifier as recorded in a journal. | |
void | SetName (const char *name) |
Sets the custom name of the object. | |
Represents a section
Section consists of "chained_entity", a chain or a single entity of edge or curve.
The entire chain(or a single entity) may be used by the section or only a portion of the chain (or single entity) might be used. The portion of the chain (or single entity) that is used is defined by the "start_connector" and "end_connector".
start_connector: It represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used.
start_connector_intersection_point: The point of intersection of the "chained_entity" and the "start_connector". This is used to determine what portion of the chain to use in case the "start_connector" intersects the "chained_entity" in multiple locations.
end_connector: It represents the end of the portion of the chain (or single entity) that is used.
end_connector_intersection_point: The point of intersection of the "chained_entity" and the "end_connector". This is used to determine what portion of the chain to use in case the "end_connector" intersects the "chained_entity" in multiple locations.
To create a new instance of this class, use SectionCollection::CreateSection
Created in NX3.0.0.
void NXOpen::Section::AddChainBetweenIntersectionPoints | ( | const std::vector< NXOpen::SelectionIntentRule * > & | rules, |
NXOpen::NXObject * | startConnector, | ||
const NXOpen::Point3d & | startIntersectionPoint, | ||
NXOpen::NXObject * | endConnector, | ||
const NXOpen::Point3d & | endIntersectionPoint, | ||
NXOpen::NXObject * | seed, | ||
const NXOpen::Point3d & | helpPoint, | ||
NXOpen::Section::Mode | featureMode, | ||
bool | chainWithinFeature | ||
) |
Adds a chain between given two intersection points to the section.
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
rules | Selection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details. |
startConnector | It represents the start of the portion of the chain (or single entity) that is used. If "startConnector" is NULL, then the start point of the chained entity along its "natural" direction is used. It can be point, curve or edge |
startIntersectionPoint | The point where the start connector intersects with the chain. |
endConnector | Represents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge |
endIntersectionPoint | The point where the end connector intersects with the chain. |
seed | Seed curve, edge or face |
helpPoint | The point which is used to determine which portion of the chain to use for creating section. |
featureMode | Feature create or edit mode. |
chainWithinFeature | True if chaining and discovery of intersection limits is to be restricted to the feature of the seed. This is effective only when the seed belongs to a curve feature. |
void NXOpen::Section::AddSmartPoint | ( | NXOpen::Point * | smartPt, |
double | tol | ||
) |
Add smart point into section.
<br>
This API is now deprecated. Please use ScRuleFactory::CreateRuleCurveDumb and Section::AddToSection instead.
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
smartPt | Smart point tobe added into section. |
tol | Tolerance. |
void NXOpen::Section::AddToSection | ( | const std::vector< NXOpen::SelectionIntentRule * > & | rules, |
NXOpen::NXObject * | seed, | ||
NXOpen::NXObject * | startConnector, | ||
NXOpen::NXObject * | endConnector, | ||
const NXOpen::Point3d & | helpPoint, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Adds selection intent rules to the section.
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
rules | Selection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details. |
seed | Seed curve, edge or face |
startConnector | It represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be point, curve or edge |
endConnector | It represents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge |
helpPoint | This is used to determine which portion of the chain to use for creating section. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::AddToSection | ( | const std::vector< NXOpen::SelectionIntentRule * > & | rules, |
NXOpen::NXObject * | seed, | ||
NXOpen::NXObject * | startConnector, | ||
NXOpen::NXObject * | endConnector, | ||
const NXOpen::Point3d & | helpPoint, | ||
NXOpen::Section::Mode | featureMode, | ||
bool | chainWithinFeature | ||
) |
Adds selection intent rules to the section with the option of restricting chaining and limit discovery to a single feature.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
rules | Selection intent rules. To create selection intent rules see documentation of ScRuleFactory for more details. |
seed | Seed curve, edge or face |
startConnector | It represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be point, curve or edge |
endConnector | It represents the end of the portion of the chain (or single entity) that is used. It can be point, curve or edge |
helpPoint | This is used to determine which portion of the chain to use for creating section. |
featureMode | Feature create or edit mode. |
chainWithinFeature | True if chaining and discovery of intersection limits is to be restricted to the feature of the seed. This is effective only when the seed belongs to a curve feature. |
void NXOpen::Section::AlignDirectionOfLoop | ( | const NXOpen::Point3d & | point, |
const NXOpen::Vector3d & | direction | ||
) |
Set the direction of a single loop of the section along the given vector.
Created in NX5.0.1.
License requirements : gateway ("UG GATEWAY")
point | Any point on a the desired loop. |
direction | Desired tangent direction of the loop at the point. |
void NXOpen::Section::AllowSelfIntersection | ( | bool | allowSelfIntersection | ) |
Allow self intersecting section or not.
By default self intersection is allowed.
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
allowSelfIntersection | True if self-intersecting section is allowed else false |
double NXOpen::Section::AngleTolerance | ( | ) |
Returns the angle tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
double NXOpen::Section::ChainingTolerance | ( | ) |
Returns the chaining tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
void NXOpen::Section::CleanMappingData | ( | ) |
Cleans Mapping Data
This method should be used to clean mapping data after mapping is done
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
void NXOpen::Section::Clear | ( | ) |
Clear the section of all its constituents
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
NXOpen::Section* NXOpen::Section::CloneSection | ( | ) |
Clone section.
void NXOpen::Section::DeselectPortion | ( | const NXOpen::Point3d & | seedPoint, |
NXOpen::NXObject * | startLimit, | ||
NXOpen::NXObject * | endLimit, | ||
NXOpen::Section::DeselectOption | deselectionType | ||
) |
Deselects Portion of the section depending on the option provided.
<br>
This method should be used to deselect portion of the section.
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
seedPoint | The seed point of deselection |
startLimit | The element that is connected to the curve/edge near its start point. |
endLimit | The element that is connected to the curve/edge near its end point. |
deselectionType | The deselection type |
void NXOpen::Section::Destroy | ( | ) |
Destroy the section object
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
double NXOpen::Section::DistanceTolerance | ( | ) |
Returns the distance tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
void NXOpen::Section::EvaluateAndAskOutputEntities | ( | std::vector< NXOpen::NXObject * > & | refs | ) |
Recalculates section collection.
<br>
This is JA API for recalculating the section collection and to get the section collection after recalculation.
Created in NX9.0.0.
License requirements : gateway ("UG GATEWAY")
refs | The array of section elements. |
NXOpen::Section::AllowTypes NXOpen::Section::GetAllowedEntityTypes | ( | ) |
Get the Allowed Entity Types.
<br>
Works only for UF_SC_CURVE_dumb_data_s and UF_SC_CURVE_feature_data_s
int NXOpen::Section::GetLoopIndex | ( | NXOpen::NXObject * | sectionElement | ) |
Returns the index of the section loop conatining the section element.
If the section element does not exist in the section or is part of more than one loops, this method will return an error. @return loop Index
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
sectionElement | an element that constructs the section |
int NXOpen::Section::GetLoopIndex | ( | const NXOpen::Point3d & | pointSpecifyingLoop, |
double | tolerance | ||
) |
Returns the index of the loop on which the given point lies.
pointSpecifyingLoop | a point lying on the loop for which the loop index is being queried |
tolerance | Tolerance for specifying point on loop. |
bool NXOpen::Section::GetMultiComponent | ( | ) |
Gets the option set on Section for collection from multiple components.
<br>
A multi-component Section can have collection from multiple components i.e., multiple parts or multiple instances of same part or both.
bool NXOpen::Section::GetNonFeatureMode | ( | ) |
void NXOpen::Section::GetOldOutputCurves | ( | std::vector< NXOpen::NXObject * > & | oldOutputs | ) |
Gives the old output curves of the section.
<br>
This method returns an array of old section curves. They were created internally and are different from the parent curves used to build the section. These curves should not be modified or deleted, doing so may result in part corruption and session may become unstable.
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
oldOutputs | The array of old section elements. |
void NXOpen::Section::GetOutputCurves | ( | std::vector< NXOpen::NXObject * > & | outputs | ) |
Gives the output curves of the section.
<br>
This method returns an array of existing section curves. They are created internally and are different from the parent curves used to build the section. These curves should not be modified or deleted, doing so may result in part corruption and session may become unstable.
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
outputs | The array of section elements. |
void NXOpen::Section::GetSectionData | ( | std::vector< NXOpen::SectionData * > & | sectionData | ) |
Gets the section data
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
sectionData | Section data consists of selection intent rules, section elements, start and end connector. |
void NXOpen::Section::GetStartAndDirection | ( | NXOpen::ICurve ** | startElement, |
NXOpen::Point3d * | startPoint, | ||
NXOpen::Vector3d * | direction | ||
) |
Gets the start element and the direction of the section.
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
startElement | The element, curve or edge, specifying the starting of the section. If the section is a loop, then the loop is started by start_element and the direction is followed the input direction. If the section is not a loop, then the section can be started by other element, but the direction of the section is defined by the start_element and direction. |
startPoint | The origin of the vector that defines the direction of the section. This point has to be on the start_element. |
direction | The direction of the vector defines the direction of the section. |
void NXOpen::Section::GetStartAndDirectionOfLoop | ( | int | index, |
NXOpen::Point3d * | startPoint, | ||
NXOpen::Vector3d * | direction | ||
) |
Gets the start point and the direction of a specified single loop of the section.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
index | The index of the loop of the section for which start point and direction are being queried. |
startPoint | The origin of the vector that defines the direction of the loop of the section specified by the index. |
direction | The direction of the vector defines the direction of the loop of the section specified by the index. |
void NXOpen::Section::MapSectionElements | ( | NXOpen::NXObject * | oldWf, |
NXOpen::NXObject * | newWf | ||
) |
Maps old section curves to new section curves
This method should be used to map old section curves to new section curves when some or all curves from section are removed and some or all new curves are added.
<br> <br>
To find old section curves see documentation for Section::GetOldOutputCurves and to find current section curves see documentation for Section::GetOutputCurves
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
oldWf | The old section curve which was removed and hence needs to be mapped. |
newWf | The new section curve that would be mapped to the old section curve. |
void NXOpen::Section::PrepareMappingData | ( | ) |
Prepares Mapping Data
This method should be used to create mapping data if mapping is to be done
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
void NXOpen::Section::RemoveMultipleCurves | ( | const std::vector< NXOpen::ICurve * > & | wfs, |
const std::vector< NXOpen::NXObject * > & | startConnector, | ||
const std::vector< NXOpen::NXObject * > & | endConnector, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes multiple section elements that are either curves/edges.
<br>
This API is now deprecated. Please use Section::RemoveMultipleElements instead.
Created in NX6.0.2.
License requirements : None
wfs | The elements (curves/edges) that construct the section. |
startConnector | The element that is connected to the curve/edge near its start point. |
endConnector | The element that is connected to the curve/edge near its end point. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::RemoveMultipleElements | ( | const std::vector< NXOpen::ICurve * > & | wfs, |
const std::vector< NXOpen::NXObject * > & | startConnectors, | ||
const std::vector< NXOpen::NXObject * > & | endConnectors, | ||
const std::vector< bool > & | isCombinationsResultIntoOnlyOneCurvePerCombination, | ||
const std::vector< NXOpen::Point3d > & | pointsOnCurvesToBeRemoved, | ||
const std::vector< NXOpen::Point * > & | points, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes multiple section elements.
<br>
This method should be used to remove the multiple section elements from section when elements to be removed contains points, and some or all curves that can not be uniquely mapped with wireframe , start connector and end connector. For Such curves point laying on the curve should be specified
Created in NX6.0.2.
License requirements : gateway ("UG GATEWAY")
wfs | The elements (curves/edges) that construct the section. |
startConnectors | The element that is connected to the curve/edge near its start point. |
endConnectors | The element that is connected to the curve/edge near its end point. |
isCombinationsResultIntoOnlyOneCurvePerCombination | Whether the combination of input curve/edge, Start Connector end Connector produces unique combination (i.e. they map to single section element) or not. |
pointsOnCurvesToBeRemoved | If Combination can not define curve to be deselected uniquely, then point which lies on the curve to be removed should be provided, otherwise point must be given as (0, 0, 0) for corresponding combination |
points | The points that are part of section and to be removed from the section. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::RemoveMultiplePoints | ( | const std::vector< NXOpen::Point * > & | points, |
NXOpen::Section::Mode | featureMode | ||
) |
Removes multiple section elements that are points.
<br>
This API is now deprecated. Please use Section::RemoveMultipleElements instead.
Created in NX6.0.2.
License requirements : gateway ("UG GATEWAY")
points | The points that construct the section. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::RemoveRules | ( | const std::vector< NXOpen::SelectionIntentRule * > & | rules, |
NXOpen::NXObject * | startConnector, | ||
NXOpen::NXObject * | endConnector, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes selection intent rules from the section.
<br>
To get selection intent rules of the section see documentation for Section::GetSectionData and SectionData::GetRules for more details.
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
rules | Selection intent rules. |
startConnector | It represents the start of the portion of the chain (or single entity) that is used. If "start_connector" is null (Nothing), then the start point of the chained_entity along its "natural" direction is used. It can be be point, curve or edge |
endConnector | It represents the end of the portion of the chain (or single entity) that is used. It can be be point, curve or edge |
featureMode | Feature create or edit mode |
void NXOpen::Section::RemoveRules | ( | NXOpen::ICurve * | sectionElement, |
NXOpen::NXObject * | startConnector, | ||
NXOpen::NXObject * | endConnector, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes all the selection intent rules related to the section element.
<br>
To get selection elements of the section, see documentation for Section::GetSectionData and SectionData::GetSectionElementsData for more details.
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
sectionElement | The element that constructs the section |
startConnector | The element that is connected to the section_element near its start_point |
endConnector | The element that is connected to the section_element near its end_point |
featureMode | Feature create or edit mode. |
void NXOpen::Section::RemoveSingleSectionElement | ( | NXOpen::ICurve * | sectionElement, |
NXOpen::NXObject * | startConnector, | ||
NXOpen::NXObject * | endConnector, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes one section element curve.
<br>
To get selection element see documentation for Section::GetSectionData and SectionData::GetSectionElementsData for more details.
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
sectionElement | The element that constructs the section |
startConnector | The element that is connected to the section_element near its start_point |
endConnector | The element that is connected to the section_element near its end_point |
featureMode | Feature create or edit mode |
void NXOpen::Section::RemoveSingleSectionElement | ( | NXOpen::Point * | sectionElement, |
NXOpen::Section::Mode | featureMode | ||
) |
Removes one section element that is a point.
<br>
To get selection element see documentation for Section::GetSectionData and SectionData::GetSectionElementsData for more details.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
sectionElement | The point that constructs the section |
featureMode | Feature create or edit mode |
void NXOpen::Section::RemoveUnderlyingChain | ( | const NXOpen::Point3d & | pointSpecifyingChain, |
double | tolerance, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes all the selection intent rules related to the chain on which the given point lies.
<br>
This method should be used in place of Section::RemoveRules when the part containing the section element is not loaded.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
pointSpecifyingChain | The point should lie on the chain that is to be removed. |
tolerance | Tolerance for specifying point on chain. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::RemoveUnderlyingCurve | ( | const NXOpen::Point3d & | pointSpecifyingCurve, |
double | tolerance, | ||
NXOpen::Section::Mode | featureMode | ||
) |
Removes the single curve which is within tolerance to the given point, from the section.
<br>
This method should be used in place of Section::RemoveSingleSectionElement in any of the conditions: when the part containing the section element is not loaded, when the combination of input curve, start connector and end connector maps to multiple section element, or when underlying parent is invalid.
Created in NX6.0.2.
License requirements : gateway ("UG GATEWAY")
pointSpecifyingCurve | The point should lie on the curve that is to be removed. |
tolerance | Tolerance for specifying point on curve. |
featureMode | Feature create or edit mode. |
void NXOpen::Section::ReverseDirection | ( | ) |
Reverse the section direction
Created in NX4.0.0.
License requirements : gateway ("UG GATEWAY")
void NXOpen::Section::ReverseDirectionOfClosedLoop | ( | int | index | ) |
Reverse the loop direction of a closed loop while keeping the start curve same.
This API can only be used closed loops.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
index | Index of the closed loop for which the direction is to be reversed. |
void NXOpen::Section::ReverseDirectionOfLoop | ( | int | index | ) |
Reverse the direction of of a specified single loop of the section.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
index | The index of the loop of the section that is to be reversed. |
void NXOpen::Section::SetAllowedEntityTypes | ( | NXOpen::Section::AllowTypes | allowedEntityTypes | ) |
Set the Allowed Entity Types.
<br>
Works only for UF_SC_CURVE_dumb_data_s and UF_SC_CURVE_feature_data_s
Created in NX7.5.0.
License requirements : gateway ("UG GATEWAY")
allowedEntityTypes | Allowed entity types. |
void NXOpen::Section::SetAngleTolerance | ( | double | angleTolerance | ) |
Sets the angle tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
angleTolerance | angle tolerance |
void NXOpen::Section::SetChainingTolerance | ( | double | chainingTolerance | ) |
Sets the chaining tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
chainingTolerance | chaining tolerance |
void NXOpen::Section::SetDistanceTolerance | ( | double | distanceTolerance | ) |
Sets the distance tolerance
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
distanceTolerance | distance tolerance |
void NXOpen::Section::SetInterpart | ( | bool | interpart | ) |
Set inter-part state of section and make it empty.
<br>
This function sets the value of interpart flag on Section. Error will be raised while setting this option on Section in following conditions: (1) Multi-component option is already set on Section.
Created in NX6.0.0.
License requirements : None
interpart | True to set section interpart |
void NXOpen::Section::SetMultiComponent | ( | ) |
Sets the true option on Section for collection from multiple components.
<br>
A multi-component Section can have collection from multiple components i.e., multiple parts or multiple instances of same part or both. This method should be used only if such collection is desired. Error will be raised while setting this option on Section in following conditions: (1) Inter-part option is already set on Section.
Created in NX9.0.0.
License requirements : None
void NXOpen::Section::SetNonFeatureMode | ( | ) |
Sets the true option on Section for collection in non-feature mode.
<br>
A Section in non-feature mode does not reference the feature data of the part from which the collection is done. The option should be set on an empty Section only. For a non-empty Section, setting this option will raise error in following conditions: (1) Section is referencing feature data and non-feature mode is set true. (2) Section is not referencing feature data and non-feature mode is set false.
Created in NX9.0.0.
License requirements : None
void NXOpen::Section::SetStartAndDirection | ( | NXOpen::ICurve * | startElement, |
const NXOpen::Point3d & | startPoint, | ||
const NXOpen::Vector3d & | direction | ||
) |
Sets the start element and the direction of the section.
Created in NX3.0.0.
License requirements : gateway ("UG GATEWAY")
startElement | The element, curve or edge, specifying the starting of the section. If the section is a loop, then the loop is started by start_element and the direction is followed the input direction. If the section is not a loop, then the section can be started by other element, but the direction of the section is defined by the start_element and direction. |
startPoint | The origin of the vector that defines the direction of the section. This point has to be on the start_element. |
direction | The direction of the vector defines the direction of the section. |
void NXOpen::Section::SetStartCurveOfClosedLoop | ( | int | index, |
const NXOpen::Point3d & | pointOnStartCurve | ||
) |
Set the curve on which the specified point lies as the start curve of a specified single loop of the section.
Created in NX5.0.0.
License requirements : gateway ("UG GATEWAY")
index | Index of the loop for which the start curve is to be set. |
pointOnStartCurve | Any point on a curve that is to be set as the start curve. |
void NXOpen::Section::SkipSorting | ( | bool | skipSorting | ) |
Sets the option to skip sorting the section loops or not.
<br>
This method should be used rare scenarios. In normal situation this method should never be used. If sort option is set to true then it should be set to false after required operation is done. If sort option is set to true then section loops are not sorted and output will not be in order.
Created in NX8.0.0.
License requirements : gateway ("UG GATEWAY")
skipSorting | True to skip sorting of section loops else false |